"use strict";

window.CORS = window.CORS || (function() {
  // Create the XHR object.
  function createCORSRequest(method, url) {
    var xhr = new XMLHttpRequest();
    if ("withCredentials" in xhr) {
      // XHR for Chrome/Safari/Firefox.
      xhr.open(method, url, true);
    } else if (typeof XDomainRequest != "undefined") {
      // XDomainRequest for IE.
      xhr = new XDomainRequest();
      xhr.open(method, url);
    } else {
      // CORS not supported.
      xhr = null;
    }
    return xhr;
  }

  // Helper method to parse the title tag from the response.
  function getTitle(text) {
    return text.match('<title>(.*)?</title>')[1];
  }

  // Make the actual CORS request.
  function makeCorsRequest(url, callback) {
    // bibliographica.org supports CORS.
    url = url || 'http://bibliographica.org/';

    var xhr = createCORSRequest('GET', url);
    if (!xhr) {
      alert('CORS not supported');
      return;
    }

    // Response handlers.
    xhr.onload = function() {
      var text = xhr.responseText;
      // var title = getTitle(text);
      // alert('Response from CORS request to ' + url + ': ' + title);
      if (typeof callback == 'function') {
        callback(text);
      }
    };

    xhr.onerror = function() {
      console.warn('Woops, there was an error making the request.');
    };

    xhr.send();
  }
  return {
    create: createCORSRequest,
    send: makeCorsRequest
  };
} ());
