(function () {
    'use strict'

    App.MaxTVListPrograms = 12;
    App.internetConnectionPopup = null;

    var networkPlugin;
    App.checkConnection = function () {
        networkPlugin = networkPlugin || document.querySelector('#pluginObjectNetwork');
        if (!networkPlugin) {
            return true;
        }

        var physicalConnection = 0,
            httpStatus = 0,
            currentInterface = networkPlugin.GetActiveType();

        if (currentInterface === -1) {
            return false;
        }

        physicalConnection = networkPlugin.CheckPhysicalConnection(currentInterface);

        if (physicalConnection !== 1) {
            return false;
        }

        httpStatus = networkPlugin.CheckHTTP(currentInterface);

        if (httpStatus !== 1) {
            return false;
        }

        return true;
    }

    setInterval(function () {
        if (!App.internetConnectionPopup) {
            return;
        }

        if (!App.checkConnection()) {
            // no internet connection

            if (!$('body').hasClass('network-error')) {
                if (App.TrailerView.get('shown')) {
                    App.BackController.action();
                }

                setTimeout(function () {
                    $('body').addClass('network-error');
                    App.internetConnectionPopup.css('left', 0);
                }, 500);
            }
        } else {
            if ($('body').hasClass('network-error')) {
                $('body').removeClass('network-error');
                App.internetConnectionPopup.css('left', 10000);
            }
        }
    }, 2000);

    App.log = function (server) {
        if (server === true) {
            var newArguments = Array.prototype.slice.call(arguments, 1);
            if (newArguments) {
                var options = {
                    debug: true,
                    platform: ENV.PLATFORM_NAME,
                    ua: window.location.search.substr(1),
                    text: JSON.stringify(Array.prototype.map.call(newArguments, String)),
                    is_dev: Number(ENV.IS_DEV)
                };
                App.log('$.post', ENV.REQUEST_HANDLER, JSON.stringify(options));
                $.post(ENV.REQUEST_HANDLER, options);
            }
            return;
        }
        if (ENV.IS_DEV || ENV.LOGGING) {
            if (App.StatusView && ENV.LOGGING) {
                App.StatusView.set('shown', true);
                var newLine = Array.prototype.map.call(arguments, String).join(' '),
                    lines = App.StatusView.get('text') ? App.StatusView.get('text').split('<br />') : [];
                lines.push(newLine);
                App.StatusView.set('text', lines.slice((lines.length - 2 > 0) ? lines.length - 2 : 0, 2).join('<br />'));
            }
            alert(Array.prototype.map.call(arguments, String).join(' '));
        }
    };

    ENV.VERSION = '1.1';
    ENV.TEMPLATE_DIR = 'core/js/templates/';
    ENV.REQUEST_HANDLER = (ENV.IS_DEV ? 'http://vadim-dev.' : 'http://www.') + 'kinopoisk.ru/api/tv/1.1/handler_tv.php';

    for (var id in tvKey) {
        ENV.KEY[id.slice(4)] = tvKey[id];
    }

    // Native and embedded Handlebars incompatibility?
    for (var templ in Em.Handlebars.templates) {
        Em.TEMPLATES[templ] = Em.TEMPLATES[templ] || Em.Handlebars.templates[templ];
    }

    /**
     * Device UA: Mozilla/5.0 (SmartHub; SMART-TV; U; Linux/SmartTV; Maple2012) AppleWebKit/534.7 (KHTML, like Gecko) SmartTV Safari/534.7
     * location.search.substr(1):
     * Emulator: country=US&language=1&lang=en&kp_modelid=SDK&server=development&firmware=T-INFOLINK2013-1000&remocon=4_35_259_12&area=USA
     * Device:
     *      country=RU&
     *      samsung_country=RU&
     *      language=21&
     *      lang=ru&
     *      kp_modelid=12_ECHOP&
     *      server=operation&
     *      remocon=0_650_259_13&
     *      area=PANEURO&
     *      product=0&
     *      mgrver=4.531&
     *      totalMemory=791674880&
     *      webbrowser=true&
     *      sourcetype=0
     **/

    ENV.KEY.FUNCTIONAL_ARRAY = [
        ENV.KEY.EXIT, ENV.KEY.RETURN, ENV.KEY.BLUE, ENV.KEY.ENTER, ENV.KEY.PLAY,
        ENV.KEY.PAUSE, ENV.KEY.STOP, ENV.KEY.FF, ENV.KEY.RW
    ];

    App.SamsungKeyControllerClass = App.KeyController.extend({
        keyDown: function (event) {
            App.tree.set('mouse', false);
            var key = event.which;

            if ($('body').hasClass('network-error') &&
                key !== ENV.KEY.RETURN &&
                key !== ENV.KEY.EXIT
            ) {
                return false;
            }

            if (App.TrailerView.get('shown') &&
                !App.TrailerView.get('autohideTimeout')
            ) {
                if (!App.DetailsView.get('statusLeftShown') ||
                    App.DetailsView.get('statusLeftText') != ENV.LANG.RU.LOADING_TRAILER
                ) {
                    App.TrailerView.toolbar(event);
                }
                if (ENV.KEY.FUNCTIONAL_ARRAY.indexOf(key) == -1) {
                    return;
                }
            }

            // QA restriction: return from DetailsView - only with Return button
            if (App.DetailsView.get('shown')) {

                switch (key) {
                    case ENV.KEY.UP:
                    case ENV.KEY.DOWN:
                        var scrollTop = $('.synopsis').scrollTop(),
                            lineHeight = parseInt($('.synopsis').css('lineHeight')),
                            direction = key == ENV.KEY.UP ? -1 : 1;
                        $('.synopsis').scrollTop(scrollTop + lineHeight * direction);
                        App.DetailsView.set('scrollBarTop', $('.synopsis').scrollTop());
                        setTimeout(function () {
                            App.DetailsView.set('scrollBarHeight',
                                Math.round($('.synopsis').innerHeight() / $('.synopsis').get(0).scrollHeight * 100));
                        }, 0);
                    break;

                    default:
                    break;
                }

                if (ENV.KEY.FUNCTIONAL_ARRAY.indexOf(key) == -1 || key == ENV.KEY.ENTER) {
                    return false;
                }
            }

            /* Global Keys */
            switch (key) {
                case ENV.KEY.RETURN:
                    App.BackController.action(event);
                break;
                case ENV.KEY.YELLOW:
                    // App.TrailerController.action();
                break;
                case ENV.KEY.GREEN:
                    // App.RefreshController.action();
                break;
                case ENV.KEY.BLUE:
                    // App.PauseController.action();
                break;
                case ENV.KEY.PAUSE:
                    if (App.TrailerView.get('shown') &&
                        App.PauseController.get('status') === 'pause'
                    ) {
                        App.PauseController.action();
                    }
                break;
                case ENV.KEY.PLAY:
                    if (App.TrailerController.get('trailerView.shown') &&
                        App.PauseController.get('status') === 'play'
                    ) {
                        App.PauseController.action();
                    } else if (!App.TrailerController.get('trailerView.shown') &&
                        App.tree.get('current.data.trailer.src')
                    ) {
                        App.TrailerController.action();
                    }
                break;
                case ENV.KEY.ENTER:
                    if (App.TrailerView.get('shown')) {
                        App.PauseController.action();
                    } else {
                        this._super(event);
                    }
                break;
                case ENV.KEY.STOP:
                    if (App.TrailerView.get('shown')) {
                        App.BackController.action();
                    }
                break;
                case ENV.KEY.EXIT:
                    App.ExitController.action(true);
                break;
                default:
                    this._super(event);
                break;
            }
        }
    });

    $(function() {
        // if (ENV.OLD) {
        //     document.querySelector('body').classList.add('old');
        // }

        // http://www.samsungdforum.com/Guide/ref00006/common_module_plugin_object.html
        // sf.service.setVolumeControl(true);
        App.start();

        App.Model.loadView('menu', function (view) {
            // App.log('menu', $('header').html(), $('header').css('backgroundImage'));
            App.Model.loadView('ruler', function (view) {
                ENV.TEMPLATE_DIR = ENV.TEMPLATE_DIR.replace('core', ENV.PLATFORM_NAME); // nice hack?
                App.Model.loadView('trailer', App.SamsungTrailerViewClass, function (view) {
                    // App.TrailerView.reopen({
                    // });
                    // App.TrailerController = doesnt work :(
                    //     App.Tree.TrailerController.create({ text: 'Посмотреть трейлер' });
                    // App.tree.appendChildren(App.TrailerController);
                    App.TrailerController.set('trailerView', view);
                });
            });
        });
        App.Model.loadView('details', function (view) {
            App.DetailsController = App.Tree.DetailsController.create({ view: view });
            // App.DetailsController.set('view', view);
        });
        App.Model.loadView('controls', function (view) {
            App.ControlsView.set('size', 'smallest');
        });
        App.Model.loadView('status');
        App.Model.loadView('keyboard');

        App.TrailerController = App.Tree.TrailerController.create({ text: 'Посмотреть трейлер' });
        App.tree.appendChildren(App.TrailerController);

        App.PauseController.reopen({
            shown: function () {
                return Em.get('App.TrailerController.trailerView.shown');
            }.property('App.TrailerController.trailerView.shown'),
            text: function () {
                return this.get('status') === 'pause' ? 'Пауза' : 'Пуск';
            }.property('status'),
            action: function () { // TODO: focus?
                if (this.get('shown')) {
                    if (this.get('status') === 'pause') {
                        App.TrailerView.play(0);
                        this.set('status', 'play');
                    } else {
                        App.TrailerView.play(1);
                        this.set('status', 'pause');
                    }
                }
            }
        });

        App.EnterControllerClass = App.Tree.ControlsNode.extend({
            shown: function () {
                if (Em.get('App.TrailerView.shown') ||
                    Em.get('App.DetailsView.shown')
                ) {
                    return false;
                }
                if (Em.get('App.Tree.RulerItemNode').detectInstance(Em.get('App.tree.current'))) {
                    if (this.get('text') != 'О фильме') {
                        this.set('text', 'О фильме');
                    }
                    return true;
                } else {
                    return false;
                }
            }.property('App.tree.current', 'App.TrailerController.trailerView.shown', 'App.DetailsView.shown'),
        });
        App.EnterController = App.EnterControllerClass.create({
            id: 'enter',
            status: 'enter',
            text: '',
            selector: '#controls .enter',
        });

        App.Navigation4WayControllerClass = App.Tree.ControlsNode.extend({
            shown: function () {
                if (Em.get('App.TrailerView.shown') ||
                    Em.get('App.DetailsView.shown')
                ) {
                    return false;
                } else {
                    if (this.get('text') != 'Навигация') {
                        this.set('text', 'Навигация');
                    }
                    return true;
                }
            }.property('App.TrailerController.trailerView.shown', 'App.DetailsView.shown'),
        });
        App.Navigation4WayController = App.Navigation4WayControllerClass.create({
            id: 'navigation_4way',
            status: 'navigation_4way',
            text: '',
            selector: '#controls .navigation.four-way',
        });

        App.NavigationVerticalControllerClass = App.Tree.ControlsNode.extend({
            shown: function () {
                if (!Em.get('App.DetailsView.shown') ||
                    Em.get('App.TrailerView.shown')
                ) {
                    if (this.get('interval')) {
                        clearInterval(this.get('interval'));
                        this.set('interval', null);
                    }
                    return false;
                }

                var currentId = App.tree.get('current').get('data').id_film;
                if (currentId && currentId != this.get('currentId')) {
                    this.set('currentId', currentId);
                    this.update();

                    return false;
                }

                if (this.get('_shown')) {
                    return true;
                } else {
                    this.update();

                    return false;
                }
            }.property('App.DetailsView.shown', 'App.TrailerController.trailerView.shown', '_shown'),
            update: function () {
                // TODO: very dirty hack
                this.set('interval', setInterval(function () {
                    if (!$('.synopsis').get(0) || !$('.synopsis').text() || $('.synopsis').text() == 'Загрузка...') {
                        return false;
                    } else {
                        clearInterval(this.get('interval'));
                        this.set('interval', null);
                        var innerHeight = $('.synopsis').innerHeight(),
                            scrollHeight = $('.synopsis').get(0).scrollHeight;
                        var realRatio = innerHeight / (scrollHeight + 67); // text will become higher with 15px scrollbar

                        if (innerHeight < scrollHeight) {
                            if (this.get('text') != 'Прокрутка') {
                                this.set('text', 'Прокрутка');
                            }
                            App.DetailsView.set('scrollBarHeight', Math.round(realRatio * 100));
                            this.set('_shown', true);
                        } else {
                            this.set('_shown', false);
                        }
                    }

                }.bind(this), 100));
            },
        });
        App.NavigationVerticalController = App.NavigationVerticalControllerClass.create({
            id: 'navigation_vertical',
            status: 'navigation_vertical',
            text: 'Прокрутка',
            selector: '#controls .navigation.vertical',
            interval: null,
            currentId: null,
            _shown: false,
        });

        App.keyController = App.SamsungKeyControllerClass.create();
        // App.mouseController = App.MouseController.create();

        App.RefreshController.reopen({
            text: 'Обновить',
            shown: false,
        });

        App.BackController.reopen({
            text: 'Назад',
            action: function (event) {
                if ($('body').hasClass('network-error')) {
                    widgetAPI.sendReturnEvent();
                    return;
                }
                window.history.pushState({}, document.title, '#' + Math.random());
                if (event) {
                    event.preventDefault();
                }
                this._super();
            }
        });

        App.ExitController.reopen({
            text: 'Выход',
            shown: function () {
                return App.tree.get('current') === App.NowRulerController;
            }.property('App.tree.current'),
            action: function (exitButton) {
                App.TrailerController.set('trailerView.shown', false);
                App.DetailsView.set('shown', false);
                if (exitButton) {
                    App.log('exit');
                    widgetAPI.blockNavigation(event);
                    widgetAPI.sendExitEvent();
                } else {
                    App.log('return');
                    widgetAPI.blockNavigation(event);
                    widgetAPI.sendReturnEvent();
                }
            }
        });

        App.SamsungTrailerViewClass = /*App.TrailerViewClass*/Em.View.extend({
            autohideTimeout: false,
            src: '',
            type: 'application/x-netcast-av',
            width: 1280,
            height: 720,
            classNameBindings: ['shown'],
            errorText: 'При воспроизведении видео возникла ошибка.<br />Пожалуйста, сообщите нам о ней: tv@kinopoisk.ru',
            shown: false,
            toolbar: function (event) {
                // hide toolbar
                if (typeof event === 'undefined' &&
                    !(App.DetailsView.get('statusLeftShown') &&
                        App.DetailsView.get('statusLeftText') == ENV.LANG.RU.LOADING_TRAILER)
                ) {
                    clearTimeout(this.get('autohideTimeout'));
                    this.set('autohideTimeout', false);
                } else {
                    clearTimeout(this.get('autohideTimeout'));
                    this.set('autohideTimeout', setTimeout(this.toolbar.bind(this), 3000));
                }
            },
            progress: function (percent) {
                var media = this.$('video').get(0);

                if (!media || (isNaN(percent) && !media.duration)) {
                    return false;
                }

                if (isNaN(percent)) {
                    percent = parseFloat(media.currentTime) / parseFloat(media.duration);
                }
                $('#progress').css('width', parseInt(percent * (1280 - 2 * 32)) + 'px');

                var time = moment().hour(0).minute(0).second(media.currentTime).format('mm:ss'),
                    duration = moment().hour(0).minute(0).second(media.duration).format('mm:ss'),
                    statusTime = [ time, duration ].join(' / ');

                App.DetailsView.set('statusLeftText', statusTime);

                if (App.DetailsView.get('statusLeftColor') != 'white') {
                    App.DetailsView.set('statusLeftColor', 'white');
                }

                if (App.ControlsView.get('shown') &&
                    !App.DetailsView.get('statusLeftShown')
                ) {
                    App.DetailsView.set('statusLeftShown', true);
                }
            },
            logWeirdClose: function () {
                if (/fox/.test(window.location.search.toLowerCase())) {
                    var model = window.location.search.substr(1).split('&').filter(function (item) {
                        return /modelid/.test(item);
                    });
                    if (model && model.length) {
                        model = model[0].replace('modelid=', '');
                    }
                    var media = this.$('video') ? this.$('video').get(0) : null;
                    var video = media ? {
                        currentTime: media.currentTime,
                        duration: media.duration,
                        paused: media.paused,
                        ended: media.ended,
                        networkState: media.networkState,
                        readyState: media.readyState,
                        error: media['error'],
                        src: media.src,
                        currentSrc: media.currentSrc,
                    } : null;
                    var data = {
                        model: model,
                        pauseStatus: App.PauseController.get('status'),
                        statusLeftText: App.DetailsView.get('statusLeftText'),
                        autohideTimeout: App.TrailerView.get('autohideTimeout'),
                        video: video
                    };
                    App.log(true, JSON.stringify(data));
                }
            },
            shownChanged: function () {
                if (!this.get('shown')) {
                    this.progress(0);
                    App.DetailsView.set('statusLeftText', '');
                    App.DetailsView.set('statusLeftShown', false);
                    App.PauseController.set('status', 'pause');

                    this.setProperties({
                        src: '',
                        width: 1280,
                        height: 720
                    });

                    this.$('#progress').removeClass('shown'); // TODO: this is not Ember-like
                    this.logWeirdClose();
                } else {
                    App.DetailsView.set('statusLeftText', ENV.LANG.RU.LOADING_TRAILER);
                    App.DetailsView.set('statusLeftColor', 'gray');
                    App.DetailsView.set('statusLeftShown', true);
                    this.toolbar(); // remove autohideTimeout

                    var trailer = Em.get('App.tree.current.data.trailer');
                    var ratio = trailer.tr_width / trailer.tr_height,
                        screenRatio = $(window).width() / $(window).height(),
                        width = ratio > screenRatio ? $(window).width() : $(window).height() * ratio,
                        height = ratio > screenRatio ? $(window).width() / ratio : $(window).height();

                    this.setProperties({
                        // src: trailer.src,
                        width: width,
                        height: height
                    });

                    Em.run.scheduleOnce('afterRender', this, function () {
                        $('#trailer').css({
                            paddingLeft: ($(window).width() - width) * 0.5,
                            paddingTop: ($(window).height() - height) * 0.5
                        });

                        var media = this.$('video').get(0);

                        media.addEventListener('play', function () {
                            App.TrailerView.toolbar(true); // restore autohideTimeout
                            App.DetailsView.set('statusLeftShown', false);
                        }, false);

                        media.addEventListener('timeupdate', this.progress.bind(this), false);
                        media.addEventListener('ended', App.BackController.action, false);

                        media.src = Em.get('App.tree.current.data.trailer.src');
                        media.load();
                        media.play(1);
                    });
                }
            }.observes('shown'),
            play: function (speed) {
                var media = this.$('video').get(0);
                if (speed == 0) {
                    media.pause();
                } else {
                    media.play();
                }
            }
        });

        $('body')
            .keydown(App.keyController.keyDown.bind(App.keyController));
            // .click(App.mouseController.click.bind(App.mouseController))
            // .focus(App.mouseController.focus.bind(App.mouseController))
            // .mousemove(App.mouseController.move);

        var internetConnectionPopup = $('<div class="network-error-popup"></div>').css({
            width: 1280,
            height: 640,
            backgroundColor: 'black',
            position: 'absolute',
            left: 10000,
            top: 0,
            zIndex: 1000
        });
        internetConnectionPopup.append('<p style="margin: auto; width: 100%; height: 100%; text-align: center; padding-top: 200px;">Сеть недоступна.<br />Пожалуйста, проверьте настройки соединения.</p>');
        $('body').append(internetConnectionPopup);

        App.internetConnectionPopup = $('.network-error-popup');
    });
} ());
